VSTGUI: CMenuItem Class Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Classes | Public Types | Public Member Functions | List of all members
CMenuItem Class Reference

a menu item More...

`#include <coptionmenu.h>`

Inheritance diagram for CMenuItem:

## Classes
struct | Impl

## Public Types
enum | Flags { kNoFlags = 0 , kDisabled = 1 << 0 , kTitle = 1 << 1 , kChecked = 1 << 2 , kSeparator = 1 << 3 }

## Public Member Functions
| CMenuItem (const UTF8String &title, const UTF8String &keycode="", int32_t keyModifiers=0, CBitmap *icon=nullptr, int32_t flags=kNoFlags)
| CMenuItem constructor. More...
| CMenuItem (const UTF8String &title, COptionMenu *submenu, CBitmap *icon=nullptr)
| CMenuItem constructor. More...
| CMenuItem (const UTF8String &title, int32_t tag)
| CMenuItem constructor. More...
| CMenuItem (const CMenuItem &item)
| CMenuItem copy constructor. More...
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexcept override=default
| CBaseObject (const CBaseObject &)
CBaseObject & | operator= (const CBaseObject &)
virtual CMessageResult | notify (CBaseObject *sender, IdStringPtr message)
Public Member Functions inherited from ReferenceCounted< T >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0 More...
void | remember () override
| increase refcount More...
virtual int32_t | getNbReference () const
| get refcount More...
virtual void | forget ()=0
| decrease refcount and delete object if refcount == 0 More...
virtual void | remember ()=0
| increase refcount More...

## CMenuItem Methods
std::unique_ptr< Impl > | impl
virtual void | setTitle (const UTF8String &title)
| set title of menu item More...
virtual void | setSubmenu (COptionMenu *submenu)
| set submenu of menu item More...
virtual void | setKey (const UTF8String &keyCode, int32_t keyModifiers=0)
| set keycode and key modifiers of menu item More...
virtual void | setVirtualKey (VirtualKey virtualKey, int32_t keyModifiers=0)
| set virtual key and key modifiers of menu item More...
virtual void | setEnabled (bool state=true)
| set menu item enabled state More...
virtual void | setChecked (bool state=true)
| set menu item checked state More...
virtual void | setIsTitle (bool state=true)
| set menu item title state More...
virtual void | setIsSeparator (bool state=true)
| set menu item separator state More...
virtual void | setIcon (CBitmap *icon)
| set menu item icon More...
virtual void | setTag (int32_t tag)
| set menu item tag More...
bool | isEnabled () const
| returns whether the item is enabled or not More...
bool | isChecked () const
| returns whether the item is checked or not More...
bool | isTitle () const
| returns whether the item is a title item or not More...
bool | isSeparator () const
| returns whether the item is a separator or not More...
const UTF8String & | getTitle () const
| returns the title of the item More...
int32_t | getKeyModifiers () const
| returns the key modifiers of the item More...
const UTF8String & | getKeycode () const
| returns the keycode of the item More...
VirtualKey | getVirtualKey () const
| returns the virtual key of the item More...
COptionMenu * | getSubmenu () const
| returns the submenu of the item More...
CBitmap * | getIcon () const
| returns the icon of the item More...
int32_t | getTag () const
| returns the tag of the item More...
int32_t | getVirtualKeyCode () const
virtual void | setVirtualKey (int32_t virtualKeyCode, int32_t keyModifiers=0)
| CMenuItem ()
| ~CMenuItem () noexcept override

## Detailed Description

a menu item

Defines an item of a VSTGUI::COptionMenu

## Member Enumeration Documentation

## ◆ Flags

enum Flags

Enumerator
kNoFlags |
kDisabled | item is gray and not selectable
kTitle | item indicates a title and is not selectable
kChecked | item has a checkmark
kSeparator | item is a separator

## Constructor & Destructor Documentation

## ◆ CMenuItem() [1/5]

CMenuItem | ( | const UTF8String & | inTitle,
|  | const UTF8String & | inKeycode = `""`,
|  | int32_t | inKeyModifiers = `0`,
|  | CBitmap * | inIcon = `nullptr`,
|  | int32_t | inFlags = `kNoFlags`
| ) |  |

CMenuItem constructor.

Parameters

  inTitle | title of item
  inFlags | CMenuItem::Flags of item
  inKeycode | keycode of item
  inKeyModifiers | keymodifiers of item
  inIcon | icon of item

## ◆ CMenuItem() [2/5]

CMenuItem | ( | const UTF8String & | inTitle,
|  | COptionMenu * | inSubmenu,
|  | CBitmap * | inIcon = `nullptr`
| ) |  |

CMenuItem constructor.

Parameters

  inTitle | title of item
  inSubmenu | submenu of item
  inIcon | icon of item

## ◆ CMenuItem() [3/5]

CMenuItem | ( | const UTF8String & | inTitle,
|  | int32_t | inTag
| ) |  |

CMenuItem constructor.

Parameters

  inTitle | title of item
  inTag | tag of item

## ◆ CMenuItem() [4/5]

CMenuItem | ( | const CMenuItem & | item | ) |

CMenuItem copy constructor.

Parameters

  item | item to copy

## ◆ CMenuItem() [5/5]

CMenuItem | ( |  | ) |
| protected

## ◆ ~CMenuItem()

~CMenuItem | ( |  | ) |
| overrideprotecteddefaultnoexcept

## Member Function Documentation

## ◆ getIcon()

CBitmap * getIcon | ( |  | ) | const

returns the icon of the item

## ◆ getKeycode()

const UTF8String & getKeycode | ( |  | ) | const

returns the keycode of the item

## ◆ getKeyModifiers()

int32_t getKeyModifiers | ( |  | ) | const

returns the key modifiers of the item

## ◆ getSubmenu()

COptionMenu * getSubmenu | ( |  | ) | const

returns the submenu of the item

## ◆ getTag()

int32_t getTag | ( |  | ) | const

returns the tag of the item

## ◆ getTitle()

const UTF8String & getTitle | ( |  | ) | const

returns the title of the item

## ◆ getVirtualKey()

VirtualKey getVirtualKey | ( |  | ) | const

returns the virtual key of the item

## ◆ getVirtualKeyCode()

int32_t getVirtualKeyCode | ( |  | ) | const

## ◆ isChecked()

bool isChecked | ( |  | ) | const

returns whether the item is checked or not

## ◆ isEnabled()

bool isEnabled | ( |  | ) | const

returns whether the item is enabled or not

## ◆ isSeparator()

bool isSeparator | ( |  | ) | const

returns whether the item is a separator or not

## ◆ isTitle()

bool isTitle | ( |  | ) | const

returns whether the item is a title item or not

## ◆ setChecked()

void setChecked | ( | bool | state = `true` | ) |
| virtual

set menu item checked state

## ◆ setEnabled()

void setEnabled | ( | bool | state = `true` | ) |
| virtual

set menu item enabled state

## ◆ setIcon()

void setIcon | ( | CBitmap * | icon | ) |
| virtual

set menu item icon

## ◆ setIsSeparator()

void setIsSeparator | ( | bool | state = `true` | ) |
| virtual

set menu item separator state

## ◆ setIsTitle()

void setIsTitle | ( | bool | state = `true` | ) |
| virtual

set menu item title state

## ◆ setKey()

void setKey | ( | const UTF8String & | keyCode,
|  | int32_t | keyModifiers = `0`
| ) |  |
| virtual

set keycode and key modifiers of menu item

## ◆ setSubmenu()

void setSubmenu | ( | COptionMenu * | submenu | ) |
| virtual

set submenu of menu item

## ◆ setTag()

void setTag | ( | int32_t | tag | ) |
| virtual

set menu item tag

## ◆ setTitle()

void setTitle | ( | const UTF8String & | title | ) |
| virtual

set title of menu item

## ◆ setVirtualKey() [1/2]

void setVirtualKey | ( | int32_t | virtualKeyCode,
|  | int32_t | keyModifiers = `0`
| ) |  |
| virtual

## ◆ setVirtualKey() [2/2]

void setVirtualKey | ( | VirtualKey | virtualKey,
|  | int32_t | keyModifiers = `0`
| ) |  |
| virtual

set virtual key and key modifiers of menu item

## Member Data Documentation

## ◆ impl

std::unique_ptr<Impl> impl
| protected

The documentation for this class was generated from the following files:

- coptionmenu.h
- coptionmenu.cpp